//+----------------------------------------------------------------------------+
//| TEB2 1.00.mq4
//| Copyright  5 giugno 2011, gspe
//| gspe@ae-design.ws
//| gspefx.blogspot.com
//|
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+



#property copyright "Copyright  2011, gspe"
#property link      "gspefx.blogspot.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 3
#property indicator_buffers 12
#property indicator_color1 LimeGreen
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 LimeGreen
#property indicator_color5 Red
#property indicator_color6 Yellow
#property indicator_color7 LimeGreen
#property indicator_color8 Red
#property indicator_color9 Yellow
#property indicator_color10 LimeGreen
#property indicator_color11 Red
#property indicator_color12 Yellow

//---- parameters
extern string	Lo_TF = "H1";	// Low TimeFrame
extern string	Hi_TF = "H4";	// High TimeFrame
extern string	Higher_TF = "D1";	// Low TimeFrame
extern string	Highest_TF = "W1";	// High TimeFrame

extern color	TextColor = White;
extern bool		MTF_Hi_to_Lo = true;
extern bool		ShowArrows = true;
extern color	UpArrowColor = LimeGreen;
extern color	DownArrowColor = Red;
extern bool		SendAlert = true;
extern bool		SendEmail = false;
double			Arrow_Target;
string			AlertMessageUp, AlertMessageDn;



//---- buffers
double buf1_up[];
double buf1_dn[];
double buf1_no[];
double buf2_up[];
double buf2_dn[];
double buf2_no[];
double buf3_up[];
double buf3_dn[];
double buf3_no[];
double buf4_up[];
double buf4_dn[];
double buf4_no[];


string shortname = "";
string objPrefix;	// all objects drawn by this indicator will be prefixed with this
string buff_str ;	// all objects drawn by this indicator will be prefixed with this
int ArrSymbol = 110;	//159;
int ArrowGap,t0,Signal;
bool AlertDone = false;

int Period_1, Period_2, Period_3, Period_4;
double Gap1,Gap2,Gap3,Gap4;
double UP_Arrow_Sum0, UP_Arrow_Sum1, DN_Arrow_Sum0, DN_Arrow_Sum1;

static int PrevSignal = 0;
static datetime PrevTime = 0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

	SetIndexStyle(0,DRAW_ARROW,0);
	SetIndexArrow(0,ArrSymbol);
	SetIndexBuffer(0,buf1_up);
	SetIndexEmptyValue(0,0.0);
	SetIndexStyle(1,DRAW_ARROW,0);
	SetIndexArrow(1,ArrSymbol);
	SetIndexBuffer(1,buf1_dn);
	SetIndexEmptyValue(1,0.0);
	SetIndexStyle(2,DRAW_ARROW,0);
	SetIndexArrow(2,ArrSymbol);
	SetIndexBuffer(2,buf1_no);
	SetIndexEmptyValue(2,0.0);
	SetIndexStyle(3,DRAW_ARROW,0);
	SetIndexArrow(3,ArrSymbol);
	SetIndexBuffer(3,buf2_up);
	SetIndexEmptyValue(3,0.0);
	SetIndexStyle(4,DRAW_ARROW,0);
	SetIndexArrow(4,ArrSymbol);
	SetIndexBuffer(4,buf2_dn);
	SetIndexEmptyValue(4,0.0);
	SetIndexStyle(5,DRAW_ARROW,0);
	SetIndexArrow(5,ArrSymbol);
	SetIndexBuffer(5,buf2_no);
	SetIndexEmptyValue(5,0.0);
	SetIndexStyle(6,DRAW_ARROW,0);
	SetIndexArrow(6,ArrSymbol);
	SetIndexBuffer(6,buf3_up);
	SetIndexEmptyValue(6,0.0);
	SetIndexStyle(7,DRAW_ARROW,0);
	SetIndexArrow(7,ArrSymbol);
	SetIndexBuffer(7,buf3_dn);
	SetIndexEmptyValue(7,0.0);
	SetIndexStyle(8,DRAW_ARROW,0);
	SetIndexArrow(8,ArrSymbol);
	SetIndexBuffer(8,buf3_no);
	SetIndexEmptyValue(8,0.0);
	SetIndexStyle(9,DRAW_ARROW,0);
	SetIndexArrow(9,ArrSymbol);
	SetIndexBuffer(9,buf4_up);
	SetIndexEmptyValue(9,0.0);
	SetIndexStyle(10,DRAW_ARROW,0);
	SetIndexArrow(10,ArrSymbol);
	SetIndexBuffer(10,buf4_dn);
	SetIndexEmptyValue(10,0.0);
	SetIndexStyle(11,DRAW_ARROW,0);
	SetIndexArrow(11,ArrSymbol);
	SetIndexBuffer(11,buf4_no);
	SetIndexEmptyValue(11,0.0);

   
	SetIndexLabel(0,NULL);
	SetIndexLabel(1,NULL);
	SetIndexLabel(2,NULL);
	SetIndexLabel(3,NULL);
	SetIndexLabel(4,NULL);
	SetIndexLabel(5,NULL);
	SetIndexLabel(6,NULL);
	SetIndexLabel(7,NULL);
	SetIndexLabel(8,NULL);
	SetIndexLabel(9,NULL);
	SetIndexLabel(10,NULL);
	SetIndexLabel(11,NULL);
   
	IndicatorDigits(0);

	Lo_TF = StringUpper(Lo_TF);
	Hi_TF = StringUpper(Hi_TF);
	Higher_TF = StringUpper(Higher_TF);
	Highest_TF = StringUpper(Highest_TF);
	
	Period_1 = StrToTF(Lo_TF);
	Period_2 = StrToTF(Hi_TF);
	Period_3 = StrToTF(Higher_TF);
	Period_4 = StrToTF(Highest_TF);
	
	objPrefix = WindowExpertName();
	shortname = "TEB2 ("+Lo_TF+","+Hi_TF+","+Higher_TF+","+Highest_TF+")";
	IndicatorShortName(shortname);
	
	AlertMessageUp = "TEB2  ("+TimeFrameToString(Period())+")  Buy";
	AlertMessageDn = "TEB2  ("+TimeFrameToString(Period())+")  Sell";
	
	if(MTF_Hi_to_Lo)
	{
		Gap1 = 0.5; Gap2 = 1.0; Gap3 = 1.5; Gap4 = 2.0; Arrow_Target = 1.5;
	}
	else
	{
		Gap1 = 2.0; Gap2 = 1.5; Gap3 = 1.0; Gap4 = 0.5; Arrow_Target = 1.5;
	}

//----
	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  	RemoveObjects(objPrefix);

	return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+




int start()
{
	int counted_bars=IndicatorCounted();
	//---- check for possible errors
	if(counted_bars<0) return(-1);
	//---- the last counted bar will be recounted
	if(counted_bars>0) counted_bars--;
	int limit=Bars-counted_bars;
	int i,tf;
	int Period_1_shift=0,Period_2_shift=0,Period_3_shift=0,Period_4_shift=0;
	double MainStoch1Period_1, SignStoch1Period_1, MainStoch1Period_2, SignStoch1Period_2, MainStoch2Period_1, SignStoch2Period_1, MainStoch2Period_2, SignStoch2Period_2;
	double MainStoch1Period_3, SignStoch1Period_3, MainStoch1Period_4, SignStoch1Period_4, MainStoch2Period_3, SignStoch2Period_3, MainStoch2Period_4, SignStoch2Period_4;

	//-------------------------------1----------------------------------------   
	double dif = Time[0] - Time[1];
	
	buff_str = StringConcatenate(objPrefix, "-IstoTxt-", Lo_TF);
	ObjectDelete(buff_str);
	ObjectCreate(buff_str, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*3, Gap1);
	ObjectSetText(buff_str, Lo_TF,8,"Arial", TextColor);
	buff_str = StringConcatenate(objPrefix, "-IstoTxt-", Hi_TF);
	ObjectDelete(buff_str);
	ObjectCreate(buff_str, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*3, Gap2);
	ObjectSetText(buff_str, Hi_TF,8,"Arial", TextColor);
	buff_str = StringConcatenate(objPrefix, "-IstoTxt-", Higher_TF);
	ObjectDelete(buff_str);
	ObjectCreate(buff_str, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*3, Gap3);
	ObjectSetText(buff_str, Higher_TF,8,"Arial", TextColor);
	buff_str = StringConcatenate(objPrefix, "-IstoTxt-", Highest_TF);
	ObjectDelete(buff_str);
	ObjectCreate(buff_str, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*3, Gap4);
	ObjectSetText(buff_str, Highest_TF,8,"Arial", TextColor);
   
   
	//-------------------------------2----------------------------------------
	
	for(i=limit; i>=0; i--)
	{
		Period_1_shift = iBarShift(NULL,Period_1,Time[i]);
		Period_2_shift = iBarShift(NULL,Period_2,Time[i]);
		Period_3_shift = iBarShift(NULL,Period_3,Time[i]);
		Period_4_shift = iBarShift(NULL,Period_4,Time[i]);
		
		MainStoch1Period_1 = iStochastic(NULL, Period_1, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_1_shift);
		SignStoch1Period_1 = iStochastic(NULL, Period_1, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_1_shift);
		MainStoch2Period_1 = iStochastic(NULL, Period_1, 14, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_1_shift);
		SignStoch2Period_1 = iStochastic(NULL, Period_1, 14, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_1_shift);
		
		MainStoch1Period_2 = iStochastic(NULL, Period_2, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_2_shift);
		SignStoch1Period_2 = iStochastic(NULL, Period_2, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_2_shift);
		MainStoch2Period_2 = iStochastic(NULL, Period_2, 14, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_2_shift);
		SignStoch2Period_2 = iStochastic(NULL, Period_2, 14, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_2_shift);
		
		MainStoch1Period_3 = iStochastic(NULL, Period_3, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_3_shift);
		SignStoch1Period_3 = iStochastic(NULL, Period_3, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_3_shift);
		MainStoch2Period_3 = iStochastic(NULL, Period_3, 14, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_3_shift);
		SignStoch2Period_3 = iStochastic(NULL, Period_3, 14, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_3_shift);

		MainStoch1Period_4 = iStochastic(NULL, Period_4, 5, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_4_shift);
		SignStoch1Period_4 = iStochastic(NULL, Period_4, 5, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_4_shift);
		MainStoch2Period_4 = iStochastic(NULL, Period_4, 14, 3, 3, MODE_SMA, 0, MODE_MAIN, Period_4_shift);
		SignStoch2Period_4 = iStochastic(NULL, Period_4, 14, 3, 3, MODE_SMA, 0, MODE_SIGNAL, Period_4_shift);



		{buf1_dn[i] = 0.0; buf1_up[i] = 0.0; buf1_no[i] = Gap1;}
		if		( MainStoch1Period_1 > SignStoch1Period_1 && MainStoch2Period_1 > SignStoch2Period_1 )	{buf1_up[i] = Gap1; buf1_dn[i] = 0.0; buf1_no[i] = 0.0;}
		else if	( MainStoch1Period_1 < SignStoch1Period_1 && MainStoch2Period_1 < SignStoch2Period_1 )	{buf1_dn[i] = Gap1; buf1_up[i] = 0.0; buf1_no[i] = 0.0;}
		
		{buf2_dn[i] = 0.0; buf2_up[i] = 0.0; buf2_no[i] = Gap2;}
		if		( MainStoch1Period_2 > SignStoch1Period_2 && MainStoch2Period_2 > SignStoch2Period_2 )	{buf2_up[i] = Gap2; buf2_dn[i] = 0.0; buf2_no[i] = 0.0;}
		else if	( MainStoch1Period_2 < SignStoch1Period_2 && MainStoch2Period_2 < SignStoch2Period_2 )	{buf2_dn[i] = Gap2; buf2_up[i] = 0.0; buf2_no[i] = 0.0;}

		{buf3_dn[i] = 0.0; buf3_up[i] = 0.0; buf3_no[i] = Gap3;}
		if		( MainStoch1Period_3 > SignStoch1Period_3 && MainStoch2Period_3 > SignStoch2Period_3 )	{buf3_up[i] = Gap3; buf3_dn[i] = 0.0; buf3_no[i] = 0.0;}
		else if	( MainStoch1Period_3 < SignStoch1Period_3 && MainStoch2Period_3 < SignStoch2Period_3 )	{buf3_dn[i] = Gap3; buf3_up[i] = 0.0; buf3_no[i] = 0.0;}

		{buf4_dn[i] = 0.0; buf4_up[i] = 0.0; buf4_no[i] = Gap4;}
		if		( MainStoch1Period_4 > SignStoch1Period_4 && MainStoch2Period_4 > SignStoch2Period_4 )	{buf4_up[i] = Gap4; buf4_dn[i] = 0.0; buf4_no[i] = 0.0;}
		else if	( MainStoch1Period_4 < SignStoch1Period_4 && MainStoch2Period_4 < SignStoch2Period_4 )	{buf4_dn[i] = Gap4; buf4_up[i] = 0.0; buf4_no[i] = 0.0;}

	}
   
	if(ShowArrows  && Time[0] > PrevTime)
	{
		for (i=limit; i>=0; i--)
		{
			UP_Arrow_Sum0 = (buf1_up[i+1] + buf2_up[i+1] + buf3_up[i+1] + buf4_up[i+1]);
			UP_Arrow_Sum1 = (buf1_up[i+2] + buf2_up[i+2] + buf3_up[i+2] + buf4_up[i+2]);
			DN_Arrow_Sum0 = (buf1_dn[i+1] + buf2_dn[i+1] + buf3_dn[i+1] + buf4_dn[i+1]);
			DN_Arrow_Sum1 = (buf1_dn[i+2] + buf2_dn[i+2] + buf3_dn[i+2] + buf4_dn[i+2]);
			
			MainStoch2Period_1 = iStochastic(NULL, Period_1, 14, 3, 3, MODE_SMA, 0, MODE_MAIN, i);
			SignStoch2Period_1 = iStochastic(NULL, Period_1, 14, 3, 3, MODE_SMA, 0, MODE_SIGNAL, i);
			int StochOver = 0;
			//if(MainStoch2Period_1 > 80 && SignStoch2Period_1 > 80){StochOver = 1;}
			//if(MainStoch2Period_1 < 20 && SignStoch2Period_1 < 20){StochOver = -1;}
			
			if(DN_Arrow_Sum1 != Arrow_Target && DN_Arrow_Sum0 == Arrow_Target && StochOver != -1)
			{
				ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
				buff_str = StringConcatenate(objPrefix, "Down Arrow", Time[i+1]);
				ObjectCreate(buff_str,OBJ_ARROW,0, Time[i+1],High[i+1]+ArrowGap*Point);
				ObjectSet(buff_str,OBJPROP_ARROWCODE,234);
				ObjectSet(buff_str,OBJPROP_COLOR,DownArrowColor);
				Signal=-1;
				DoAlerts(i,Signal);
			}
			
			else if (UP_Arrow_Sum1 != Arrow_Target && UP_Arrow_Sum0 == Arrow_Target && StochOver != 1)
			{
				ArrowGap = 0.5*MathCeil(iATR(NULL,0,14,i)/Point);
				buff_str = StringConcatenate(objPrefix, "Up Arrow", Time[i+1]);
				ObjectCreate(buff_str,OBJ_ARROW,0, Time[i+1],Low[i+1]-ArrowGap*Point);
				ObjectSet(buff_str,OBJPROP_ARROWCODE,233);
				ObjectSet(buff_str,OBJPROP_COLOR,UpArrowColor);
				Signal=1;
				DoAlerts(i,Signal);
			}
		}
		PrevTime = Time[0];
	}

	return(0);
}


//+------------------------------------------------------------------+
void DoAlerts(int i, int signal)
{
	if (SendAlert && i == 0)
	{
		if (AlertDone == false)
		{
			if (signal > 0)
			{
				AlertDone = true;
				Alert(AlertMessageUp+" ",Symbol());
				PlaySound("Alert.wav");
				if (SendEmail)
				{SendMail(AlertMessageUp+" ",Symbol());}
			}
			else
			if (signal < 0)
			{
				AlertDone = true;
				Alert(AlertMessageDn+" ",Symbol());
				PlaySound("Alert.wav");
				if (SendEmail)
				{SendMail(AlertMessageDn+" ",Symbol());}
			}
			else
			{AlertDone = false;}
		}
	}
}


string TimeFrameToString(int tf)
{
	string tfs;
	switch(tf)
	{
		case PERIOD_M1:  tfs="M1"  ; break;
		case PERIOD_M5:  tfs="M5"  ; break;
		case PERIOD_M15: tfs="M15" ; break;
		case PERIOD_M30: tfs="M30" ; break;
		case PERIOD_H1:  tfs="H1"  ; break;
		case PERIOD_H4:  tfs="H4"  ; break;
		case PERIOD_D1:  tfs="D1"  ; break;
		case PERIOD_W1:  tfs="W1"  ; break;
		case PERIOD_MN1: tfs="MN";
	}
	return(tfs);
}

//+------------------------------------------------------------------+
// StrToTF(string str)                                               |
//+------------------------------------------------------------------+
// Converts a timeframe string to its MT4-numeric value
// Usage:   int x=StrToTF("M15")   returns x=15
int StrToTF(string str)
{
	str = StringUpper(str);
	str = StringTrimLeft(str);
	str = StringTrimRight(str);
	
	if (str == "M1")   return(1);
	if (str == "M5")   return(5);
	if (str == "M15")  return(15);
	if (str == "M30")  return(30);
	if (str == "H1")   return(60);
	if (str == "H4")   return(240);
	if (str == "D1")   return(1440);
	if (str == "W1")   return(10080);
	if (str == "MN")   return(43200);
	return(0);
}
//+------------------------------------------------------------------+
// StringUpper(string str)                                           |
//+------------------------------------------------------------------+
// Converts any lowercase characters in a string to uppercase
// Usage:    string x=StringUpper("The Quick Brown Fox")  returns x = "THE QUICK BROWN FOX"
string StringUpper(string str)
{
	string outstr = "";
	string lower  = "abcdefghijklmnopqrstuvwxyz";
	string upper  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	for(int i=0; i<StringLen(str); i++)
	{
		int t1 = StringFind(lower,StringSubstr(str,i,1),0);
		if (t1 >=0)  
			outstr = outstr + StringSubstr(upper,t1,1);
		else
			outstr = outstr + StringSubstr(str,i,1);
	}
	return(outstr);
}

//-------------------------------------------------------------------+
// RemoveObjects                                                     |
//-------------------------------------------------------------------+
void RemoveObjects(string Pref)
{   
	int i;
	string objname = "";
	
	for (i = ObjectsTotal(); i >= 0; i--)
	{
		objname = ObjectName(i);
		if (StringFind(objname, Pref, 0) > -1) ObjectDelete(objname);
	}
	return(0);
} // End void RemoveObjects(string Pref)


